#!/usr/bin/perl -w 

package    esmith::FormMagick::Panel::htbwshaper;

use strict;
use warnings;

use esmith::FormMagick;
use esmith::ConfigDB;

our @ISA = qw(esmith::FormMagick Exporter);

our @EXPORT = qw();

our $VERSION = sprintf '%d.%03d', q$Revision: 2.00 $ =~ /: (\d+).(\d+)/;

our $db  = esmith::ConfigDB->open();

sub new
{
    shift;
    my $self = esmith::FormMagick->new();
    $self->{calling_package} = (caller) [0];
    bless $self;
    return $self;
}
sub get_interface
{
    return $db->get_prop("htbwshaper","interface");
}

sub get_RTPportStart
{
    return $db->get_prop("htbwshaper","RTPportStart");
}

sub get_RTPportEnd
{
    return $db->get_prop("htbwshaper","RTPportEnd");
}
sub get_SIPport
{
    return $db->get_prop("htbwshaper","SIPport");
}
sub get_debitup
{
    return $db->get_prop("htbwshaper","debitup");
}
sub get_debitdown
{
    return $db->get_prop("htbwshaper","debitdown");
}

sub get_active_interface
{
    my $self = shift;
    my $q = $self->{cgi};
    my $iface  = $self->localise('LABEL_INT');

	my $list = "</td></tr><tr><td class=\"sme-noborders-label\">$iface\n";
	$list .= "<td class=\"sme-noborders-content\">\n";
	$list .= "    <SELECT NAME=\"interface\" TYPE=\"select\">\n";
	my $inter="";
	my $ls_output="";
	my @ls_output="";
	my $ls_cmd = 'ls /etc/sysconfig/network-scripts/ | grep ifcfg- | grep -v lo | cut --delimiter="-" -f 2 | grep -v "\."';
	open(LS_CMD, "$ls_cmd |") or die "Blabla";
	my $i=0;
	while(<LS_CMD>){
        	next if /^total/;
		my $def_iface = get_interface();
		my $cur_iface = $_;
		chop($cur_iface);
		if($cur_iface eq $def_iface)
		{
			$list .= "<OPTION VALUE=\"$cur_iface\" SELECTED>$cur_iface";
		}
		else
		{
			$list .= "<OPTION VALUE=\"$cur_iface\">$cur_iface";
		}
	}

	$list .= "</SELECT>\n";
	return $list;
}

sub zero_or_positive
{
  my $self = shift;
  my $val = shift || 0;

  return 'OK' if($val =~ /^\d+$/ and $val >= 0);
  return $self->localise('VALUE_ZERO_OR_POSITIVE');
}
sub value_inf
{
  my $self = shift;
  my $val = shift || 0;
  my $valsup = get_RTPportStart();
  if ($val > $valsup) {
	return 'OK';
  } else {
	return $self->localise('VALUE_INF'); 
  }
}
sub change_settings 
{
    my $fm = shift;
    my $q  = $fm->{'cgi'};
    
    foreach ('RTPportStart','RTPportEnd','SIPport','debitup','debitdown','interface')
    { $db->set_prop('htbwshaper', "$_", $q->param("$_") ||''); }

    system ("/sbin/e-smith/expand-template","/etc/htbwshaper");
    system ("/etc/rc.d/init.d/masq restart 2> /dev/null > /dev/null");

    unless (system ("/etc/htbwshaper") == 0 )
    {  $fm->error('ERROR');  }

    $fm->success('SUCCESS');
}

1;
