package esmith::htbwshaper;

use strict;
use warnings;
use esmith::db;

use vars qw( $AUTOLOAD @ISA );

use esmith::DB::db;
@ISA = qw(esmith::DB::db);

our $VERSION = sprintf '%d.%03d', q$Revision: 1.18 $ =~ /: (\d+).(\d+)/;

sub open {

    my($class, $file) = @_;
    $file = $file || $ENV{ESMITH_ACCOUNT_DB} || "htbwshaper";
    return $class->SUPER::open($file);
}

sub new_record
{
    my ($self, $key, $props) = @_;

    if(getpwnam($key) || getgrnam($key))
    {

        warn "Attempt to create account '$key' which already exists ",
            "in passwd";
        return undef;
    }else{

    }
    return $self->SUPER::new_record($key, $props);
}



sub AUTOLOAD {
    my $self = shift;
    my ($called_sub_name) = ($AUTOLOAD =~ m/([^:]*)$/);
    my @types = qw(filesets);
    if (grep /^$called_sub_name$/, @types) {
        $called_sub_name =~ s/s$//g;    # de-pluralize
        return $self->get_all_by_prop(type => $called_sub_name);
    }
}
